'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * RELATIVE PATH TRANSFORM
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * =======================
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          */


var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('babel:plugin:namespace:transform-path-relative');

/**
 * Returns the relative path
 *
 * @param {String} currentFile
 * @param {String} module
 *
 * @return {String}
 */
var pathToRelative = function pathToRelative() {
    var currentFile = arguments.length <= 0 || arguments[0] === undefined ? '' : arguments[0];
    var module = arguments[1];

    /**
     * babel uses 'unknown' as a special value for filename when the transformed source can't be traced to a file
     * (e.g., transformed string)
     * @link https://github.com/babel/babel/blob/d2e7e6a/packages/babel-core/src/transformation/file/options/config.js
     */
    if (currentFile && currentFile === 'unknown') {
        debug('Warning: missing source path.');
    }

    var sourceDir = (0, _utils.resolveChdir)(_path2.default.dirname(currentFile));
    var modulePath = (0, _utils.resolve)(_path2.default.normalize(module));
    var moduleMapped = _path2.default.relative(sourceDir, modulePath);

    debug('Convert the current file to relative: "%s" (%s)', sourceDir, modulePath);

    // Support npm modules instead of directories
    if (/^(npm:)/.test(moduleMapped)) {
        var _moduleMapped$split = moduleMapped.split('npm:');

        var _moduleMapped$split2 = _slicedToArray(_moduleMapped$split, 2);

        var npmModuleName = _moduleMapped$split2[1];


        debug('The current file is npm modules: "%s"', npmModuleName);

        return npmModuleName;
    }

    if (!/^\./.test(moduleMapped)) {
        moduleMapped = './' + moduleMapped;
    }

    debug('The relative path of the current file is: "%s"', moduleMapped);

    return moduleMapped;
};

exports.default = pathToRelative;